config/routes.rb
# frozen_string_literal: true
Rails.application.routes.draw do
  resources :organizations

  resources :organizations, only: [] do
    resources :item_types do
      get 'graph_map', controller: 'states'
    end

    resources :item_types, only: [], path: '' do
      match 'summary', to: 'item_types#summary', via: :get
      resources :states
      resources :items, path: ''
    end
  end

  root 'home#index'
  match 'home/private_index' => 'home#private_index', via: :get

  # omniauth
  get '/auth/:provider/callback' => 'user_sessions#create'
  get '/auth/failure' => 'user_sessions#failure'
  get 'auth/autologin' => 'user_sessions#autologin'

  # Custom logout
  match '/logout', to: 'user_sessions#destroy', via: :all
end

app/models/state.rb
# frozen_string_literal: true
class State < ApplicationRecord
  # t.string   "name",         null: false
  # t.integer  "item_type_id", null: false
  # t.text     "description"
  # t.string   "color"
  # t.datetime "created_at",   null: false
  # t.datetime "updated_at",   null: false
  # t.index ["item_type_id", "name"], name: "index_states_on_item_type_id_and_name",
  # unique: true, using: :btree
  # t.index ["item_type_id"], name: "index_states_on_item_type_id", using: :btree

  # validations
  validates :name, presence: true, uniqueness: { scope: :item_type }
  validates :item_type, presence: true
  validates :color, length: { is: 6 }

  # relations
  belongs_to :item_type
  has_many :reachabilities, foreign_key: 'source_state_id', inverse_of: :source_state,
                            dependent: :destroy
  has_many :reachable_states, through: :reachabilities, source: :destination_state

  has_many :sources, foreign_key: 'destination_state_id', inverse_of: :destination_state,
                     dependent: :destroy, class_name: 'Reachability'
  has_many :source_states, through: :sources, source: :source_state

  has_many :items
end

app/controllers/states_controller.rb
# frozen_string_literal: true
class StatesController < ApplicationController
  before_action :set_organization
  before_action :set_item_type
  before_action :set_state, only: [:show, :edit, :update, :destroy]
  before_action :set_states, only: [:edit, :new, :create]

  skip_before_action :authenticate_api, only: :graph_map

  # GET /states
  # GET /states.json
  def index
    @states = @item_type.states.includes(:reachable_states).includes(:source_states).all
  end

  # GET /states/1
  # GET /states/1.json
  def show; end

  # GET /states/new
  def new
    @state = State.new
  end

  # GET /states/1/edit
  def edit; end

  # POST /states
  # POST /states.json
  def create
    @state = State.new(state_params)
    @state.item_type = @item_type

    respond_to do |format|
      if @state.save
        format.html do
          redirect_to [@organization, @item_type, @state], notice: 'State was successfully created.'
        end
        format.json { render :show, status: :created, location: @state }
      else
        format.html { render :new }
        format.json { render json: @state.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /states/1
  # PATCH/PUT /states/1.json
  def update
    respond_to do |format|
      if @state.update(state_params)
        format.html do
          redirect_to [@organization, @item_type, @state],
                      notice: 'State was successfully updated.'
        end
        format.json { render :show, status: :ok, location: @state }
      else
        format.html { render :edit }
        format.json { render json: @state.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /states/1
  # DELETE /states/1.json
  def destroy
    @state.destroy
    respond_to do |format|
      format.html do
        redirect_to [@organization, @item_type, :states],
                    notice: 'State was successfully destroyed.'
      end
      format.json { head :no_content }
    end
  end

  def graph_map
    @states = @item_type.states.order(:id)
    @reachabilities = @states.includes(:reachabilities).collect(&:reachabilities).flatten
  end

  private

  # Use callbacks to share common setup or constraints between actions.
  def set_state
    @state = @item_type.states.find(params[:id])
  end

  def set_states
    @states = @item_type.states.all
  end

  # Never trust parameters from the scary internet, only allow the white list through.
  def state_params
    params.require(:state).permit(:name, :item_type_id, :description, :color,
                                  reachable_state_ids: [])
  end
end

app/helpers/states_helper.rb
# frozen_string_literal: true
module StatesHelper
end

app/views/states/_form.html.haml
= form_for [organization, item_type, state] do |f|
  - if state.errors.any?
    #error-explanation
      %h2
        = pluralize(state.errors.count, 'error')
        prohibited this state from being saved:
      %ul
        - state.errors.full_messages.each do |msg|
          %li= msg
  .field
    = f.label :name
    = f.text_field :name
  .field
    = f.label :description
    = f.text_area :description
  .field
    = f.label :color
    = f.text_field :color
  .field.form-group
    = f.label :reachable_states
    .multiselect_area
      = f.collection_select :reachable_state_ids, states, :id, :name, {},
      multiple: true, class: 'form-control'
  .actions
    = f.submit 'Save'

app/views/states/edit.html.haml
%h1 Editing state

= render 'form', organization: @organization, item_type: @item_type,
state: @state, states: @states

= link_to 'Show', [@organization, @item_type, @state]
\|
= link_to 'Back', organization_item_type_states_path(@organization, @item_type)

app/views/states/index.html.haml
%h1 Listing states
%h2= @organization.name
%h3 Type: #{@item_type.title}

%table
  %thead
    %tr
      %th Name
      %th Description
      %th Color
      %th Reachable count
      %th Source count
      %th
      %th
      %th

  %tbody
    - @states.each do |state|
      %tr
        %td= state.name
        %td= state.description
        %td= state.color
        %td= state.reachable_states.size
        %td= state.source_states.size
        %td= link_to 'Show', [@organization, @item_type, state]
        %td= link_to 'Edit',
        edit_organization_item_type_state_path(@organization,
        @item_type, state)
        %td= link_to 'Destroy', [@organization, @item_type, state],
        method: :delete, data: { confirm: 'Are you sure?' }

%br

= link_to 'New State',
new_organization_item_type_state_path(@organization, @item_type)
\|
= link_to 'Item Type (back)', organization_item_type_path(@organization,
@item_type)

app/views/states/new.html.haml
%h1 New state

= render 'form', organization: @organization, item_type: @item_type,
state: @state, states: @states

= link_to 'Back', organization_item_type_states_path(@organization, @item_type)

app/views/states/show.html.haml
%p#notice= notice

%p
  %b Name:
  = @state.name
%p
  %b Item type:
  = @state.item_type.title
%p
  %b Description:
  = @state.description
%p
  %b Color:
  = @state.color
%p
  %b Reachable states:
  = @state.reachable_states.pluck(:name).to_sentence

= link_to 'Edit',
edit_organization_item_type_state_path(@organization, @item_type, @state)
\|
= link_to 'All states', organization_item_type_states_path(@organization,
@item_type)